#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<time.h>
#include "../ukk_lib/win32/ukk.h"

#define SIZE 1000000
char text[SIZE+5];
node_st *root=0;

void Show(node_st *node,int depth)
{
	int n;
	char* start,*end,*it; 
	if(!node) return;
	link_st *link=node->links; 
	while(link) {
		for(n=0; n<depth; n++) putchar('.');
		start=link->first;
		end  =link->last;  
		for(it=start; *it && (it<end || !end); it++) putchar(*it);
		for(n=depth+it-link->first; n<30; n++) putchar(' ');
		printf("n:%x  l:%x  s:%x\n",node,link,node->suff);
		Show(link->node,depth+(end-start));
		link=link->next;
	}
}


bool Test()
{
	int n,size;
	char *ref;
	char buff[80];
	size=5+rand()%70;
	for(n=0; n<size; n++) buff[n]='0'+rand()%10; buff[n]=0;
	printf("test: %s\n",buff);
	MakeTree(buff,size);
	for(n=0; n<size; n++) {
		ref=Find(buff+n,size-n);
		if(!ref) {
			printf("lost: %s\n\a",buff+n); return true;
		}
	//	if(strncmp(ref,buff+n,strlen(buff+n))) _asm { int 3 }
	}
	ClearTree();
	return false;
}


int main()
{
	int n;
	MemoryInit();
//=====
	printf("text: abaabx\n");
	root=MakeTree("abaabx",6);
	Show(root,0);
	printf("[press enter]\n"); getchar();
	ClearTree();
//=====
	printf("wait...\n");
	for(n=0; n<SIZE; n++) text[n]='0'+rand()%10; text[n]=0;
	clock_t t1=clock();
	root=MakeTree(text,SIZE);
	clock_t t2=clock();
	ClearTree();
	printf("size: %d\ntime: %dms\n",strlen(text),t2-t1);
	printf("[press enter]\n"); getchar();
//=====
	for(n=0; n<10000; n++) if(Test()) break;
	return 0;
}




