
extrn '__imp__LocalAlloc@8' as LocalAlloc:dword
extrn '__imp__LocalFree@4'  as LocalFree:dword



PAGE_SIZE	equ	4096	;  



;.data?
	BankList	dd	?	;  
	NodesList	dd	?	;    
	LinksList	dd	?	;    
	NodesCount	dd	?	;     
	LinksCount	dd	?	;     

;
;   
MemoryInit:
		xor		eax,eax
		mov		edi,BankList
		stosd
		stosd
		stosd
		mov		eax,PAGE_SIZE
		stosd
		stosd
		ret



NewBank:
		push	ebx
		push	ecx
		push	edx
		invoke	LocalAlloc,LMEM_FIXED,PAGE_SIZE
;               invoke  VirtualAlloc,0,PAGE_SIZE,MEM_COMMIT,PAGE_READWRITE
		mov		ebx,[BankList]
		mov		[eax+PAGE_SIZE-4],ebx
		mov		[BankList],eax
		pop		edx
		pop		ecx
		pop		ebx
		ret





;
NewLink:
		mov		eax,[LinksCount]
		cmp		eax,PAGE_SIZE-sizeof.link_st-4
		jc		.1
		call	NewBank
		mov		[LinksList],eax
		xor		eax,eax
.1:    push    eax
		add		eax,sizeof.link_st
		mov		[LinksCount],eax
		pop		eax
		add		eax,[LinksList]
		ret


;
NewNode:
		mov		eax,[NodesCount]
		cmp		eax,PAGE_SIZE-sizeof.node_st-4
		jc		.1
		call	NewBank
		mov		[NodesList],eax
		xor		eax,eax
.1:    push    eax
		add		eax,sizeof.node_st
		mov		[NodesCount],eax
		pop		eax
		add		eax,[NodesList]
		ret


ClearMemory:
		mov		eax,[BankList]
.1:    test    eax,eax
		jz		MemoryInit
		push	dword [eax+PAGE_SIZE-4]
		invoke	LocalFree,eax
;               invoke  VirtualFree,eax,0,MEM_RELEASE
		pop		eax
		jmp		.1


