// TreeDraw1.h: interface for the CTreeDraw class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TREEDRAW1_H__350377DA_9EDB_42D5_A572_D4433B3C9E17__INCLUDED_)
#define AFX_TREEDRAW1_H__350377DA_9EDB_42D5_A572_D4433B3C9E17__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning(disable:4786)
#include<map>
#include"../ukk_lib/win32/ukk.h"

struct tree_node_st{
link_st *real_node;
tree_node_st *next;	//  
tree_node_st *child;//  
int x; int y;		//   
int len;			//  
int corr;			//  
int scroll;			//  
bool open;			// +-
bool calc;
};

class CTreeDraw  
{
	CFont m_font;
	link_st *real_root;
	char *end_text;
	bool light_offset;		//     ;
	std::map<int,int>m_map;	//     X 
	tree_node_st *TreeRoot,*LightNode;	//    
	void Mouse(tree_node_st *node,CPoint pt,int corr);
	void CalcSize(CDC *pDC,tree_node_st *node,int x);
	void CalcArray(tree_node_st*);
	CPoint CalcSpace(tree_node_st *node);
	int CorrectMap(tree_node_st *node);
	void CorrectMap(tree_node_st *node,int x,int corr);
	CSize DrawNode(CDC *pDC,CPoint pt,tree_node_st *node,int corr);
	void Clear();
	void Clear(tree_node_st*);
	tree_node_st* ExpandNode(tree_node_st*,link_st*,int depth);
public:
	CTreeDraw();
	virtual ~CTreeDraw();
	void SetRoot(CDC*,link_st*,char *end);
	CSize Draw(CDC*);
	bool Mouse(CPoint);
	void Click(CDC*);
};

#endif // !defined(AFX_TREEDRAW1_H__350377DA_9EDB_42D5_A572_D4433B3C9E17__INCLUDED_)
